<script setup lang="ts">
  import {
    CmsElementImage,
    CmsElementManufacturerLogo,
    useCmsElementImage,
  } from '@shopware-pwa/composables-next';

  const props = defineProps<{
    content: (CmsElementImage | CmsElementManufacturerLogo) & {
      config?: {
        horizontalAlign?: {
          value?: 'flex-start' | 'flex-end' | 'center';
        };
      };
    };
  }>();

  const { containerStyle, displayMode, imageContainerAttrs, imageAttrs, imageLink }: any =
    useCmsElementImage(props.content);
</script>
<template>
  <div
    :class="{
      'relative flex h-full w-full': true,
      'items-start': content.config?.verticalAlign?.value === 'flex-start',
      'items-end': content.config?.verticalAlign?.value === 'flex-end',
      'items-center': content.config?.verticalAlign?.value === 'center',
      'justify-start': content.config?.horizontalAlign?.value === 'flex-start',
      'justify-end': content.config?.horizontalAlign?.value === 'flex-end',
      'justify-center': content.config?.horizontalAlign?.value === 'center',
    }"
  >
    <Component
      :is="imageLink.url ? 'a' : 'div'"
      v-if="imageAttrs.src"
      v-bind="imageContainerAttrs"
      :class="{
        'h-full w-full': ['cover', 'contain', 'stretch'].includes(displayMode),
      }"
    >
      <img
        :class="{
          'max-h-500': true,
          'h-full': ['cover', 'contain'].includes(displayMode),
          'w-full': ['cover', 'contain', 'stretch'].includes(displayMode),
          'object-cover': displayMode === 'cover',
          'object-contain': ['stretch', 'contain'].includes(displayMode),
          'object-top':
            displayMode === 'stretch' && content.config?.verticalAlign?.value === 'flex-start',
          'object-right-bottom':
            displayMode === 'stretch' &&
            (content.config?.verticalAlign?.value === 'flex-end' ||
              content.config?.horizontalAlign?.value === 'flex-end'),
          'object-center':
            displayMode === 'stretch' &&
            (content.config?.verticalAlign?.value === 'center' ||
              content.config?.horizontalAlign?.value === 'center'),
          'object-left-top':
            displayMode === 'stretch' &&
            (content.config?.verticalAlign?.value === 'flex-start' ||
              content.config?.horizontalAlign?.value === 'flex-start'),
        }"
        :style="displayMode === 'cover' ? containerStyle : {}"
        v-bind="imageAttrs"
        alt="Image link"
      />
    </Component>
  </div>
</template>
